<template>
  <div v-if="!allowTheme" class="object-fill" v-loading="isLoading">
    <div class="w-full min-h-20vh">
      <el-scrollbar class="flex items-center justify-center">
        <div class="w-full mx-auto">
          <el-tree
            :data="treeData"
            :props="props"
            :height="210"
            label
            @node-expand="expandNode"
            @node-collapse="collapeNode"
          >
            <template #default="{ data }">
              <div
                class="flex flex-col w-full h-fit bg-background1 rounded-lg min-w-fit"
              >
                <div
                  class="flex items-center justify-between px-5 pt-4 pb-2 border-b"
                >
                  <div>
                    <span class="mr-2">
                      <font-awesome-icon v-if="data.Layer === 0" icon="star" />
                      <font-awesome-icon v-else icon="users" />
                    </span>
                    <span class="font-bold text-md fc-text"
                      >{{ data.Username }} / {{ data.Currency }}</span
                    >
                  </div>
                  <div class="flex items-center">
                    +{{ data.ChildCount }}
                    <div class="flex items-center justify-center ml-2 text-xl">
                      <font-awesome-icon
                        v-if="!data.IsExpand && data.ChildCount > 0"
                        icon="circle-plus"
                      />
                      <font-awesome-icon v-else icon="circle-minus" />
                    </div>
                  </div>
                </div>
                <div class="flex flex-col px-5 pt-2 pb-5">
                  <div class="flex justify-between">
                    <div>This / Last Month TO :</div>
                    <div class="flex">
                      <span class="mr-3"
                        >{{ data.ThisMonthTurnoverForDisplay }} /
                        {{ data.LastMonthTurnoverForDisplay }}</span
                      >
                      <span :class="data.TurnoverMarginColor"
                        >{{ data.TurnoverMarginPercentage }} %</span
                      >
                    </div>
                  </div>
                  <div class="flex justify-between">
                    <div>This / Last Month Net TO :</div>
                    <div class="flex">
                      <span class="mr-3"
                        >{{ data.ThisMonthNetTurnoverForDisplay }} /
                        {{ data.LastMonthNetTurnoverForDisplay }}</span
                      >
                      <span :class="data.NetTurnoverMarginColor"
                        >{{ data.NetTurnoverMarginPercentage }} %</span
                      >
                    </div>
                  </div>
                </div>
              </div>
            </template>
          </el-tree>
        </div>
      </el-scrollbar>
    </div>
  </div>
  <div v-else class="object-fill diagram" v-loading="isLoading">
    <div class="w-full min-h-20vh">
      <el-scrollbar class="flex items-center justify-center">
        <div class="mx-auto w-full h-88vh">
          <el-tree
            :data="treeData"
            :props="props"
            :height="210"
            label
            @node-expand="expandNode"
            @node-collapse="collapeNode"
          >
            <template #default="{ data }">
              <div class="flex flex-col items-start w-full px-4">
                <div
                  class="flex flex-col items-start p-3 bg-background1 gap-1 w-full h-[140px] rounded-lg"
                >
                  <div
                    class="flex flex-row justify-between items-center py-1 gap-[81px] w-full border-b"
                  >
                    <span class="text-sm font-bold leading-4">
                      {{ data.Username }}/{{ data.Currency }}
                    </span>
                    <div class="flex flex-row items-center gap-1 p-0">
                      <span>+{{ data.ChildCount }}</span>
                    </div>
                  </div>
                  <div class="flex flex-col items-start w-full gap-1 py-1">
                    <div class="flex flex-row items-start gap-1 p-0">
                      <span class="text-xs leading-[14px] font-normal">
                        {{ $t("turnover") }}
                      </span>
                      <span
                        :class="data.TurnoverMarginColor"
                        class="font-bold text-xs leading-[14px]"
                      >
                        {{ data.TurnoverMarginPercentage }}%
                      </span>
                    </div>
                    <div
                      class="flex flex-row justify-between items-start p-0 gap-[33px] w-full"
                    >
                      <span class="text-xs font-normal leading-[14px] fc-text">
                        This / Last Month
                      </span>
                      <span class="text-xs font-normal leading-[14px] fc-text">
                        {{ data.ThisMonthTurnoverForDisplay }} /
                        {{ data.LastMonthTurnoverForDisplay }}
                      </span>
                    </div>
                  </div>
                  <div class="flex flex-col items-start w-full gap-1 py-1">
                    <div class="flex flex-row items-start gap-1 p-0">
                      <span class="text-xs leading-[14px] font-normal">
                        {{ $t("net_turnover") }}
                      </span>
                      <span
                        :class="data.NetTurnoverMarginColor"
                        class="font-bold text-xs leading-[14px]"
                      >
                        {{ data.NetTurnoverMarginPercentage }}%
                      </span>
                    </div>
                    <div
                      class="flex flex-row justify-between items-start p-0 gap-[33px] w-full"
                    >
                      <span class="text-xs font-normal leading-[14px] fc-text">
                        This / Last Month
                      </span>
                      <span class="text-xs font-normal leading-[14px] fc-text">
                        {{ data.ThisMonthNetTurnoverForDisplay }} /
                        {{ data.LastMonthNetTurnoverForDisplay }}
                      </span>
                    </div>
                  </div>
                </div>
              </div>
            </template>
          </el-tree>
        </div>
      </el-scrollbar>
    </div>
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { ITreeNode } from "@/models/referral/getReferral";
import { store } from "@/store";

export default defineComponent({
  components: {},
  setup() {
    const { treeData, isLoading } = useReferralDiagram();
    const props = {
      value: "CustomerId",
      label: "Currency",
      username: "Username",
      children: "Children",
    };
    const expandNode = (node: ITreeNode) => {
      node.IsExpand = true;
    };
    const collapeNode = (node: ITreeNode) => {
      node.IsExpand = false;
    };
    const allowTheme = computed(
      () =>
        store.state.selectedThemeName === "main" ||
        store.state.selectedThemeName === "black"
    );
    const { getAssetImage } = commonHelper;
    return {
      treeData,
      isLoading,
      props,
      expandNode,
      collapeNode,
      allowTheme,
      getAssetImage,
    };
  },
});
</script>
<style>
.el-scrollbar {
  overflow-x: auto;
}
</style>
<style scoped>
:deep(.el-tree-node__content) {
  width: 98% !important;
}
:deep(.el-scrollbar__wrap) {
  width: 98%;
}
</style>
